//content       does the per connection stuff
//homepage      http://www.rzuser.uni-heidelberg.de/~mkleinma/VTQL/
//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#ifndef CONNECTION_H
#define CONNECTION_H

#include <list>
#include <string>
#include <libvtql/vtql_utils.h>
#include <libvtql/sock.h>

class SockWait;
class Connection_base{
 public:
  Connection_base(const Connection_base&);//no implementation
  Connection_base(int iS,VTQL::UserMode um):umLogin(um){Con.Accept(iS);}
  virtual ~Connection_base(){};

  virtual bool Add2Poll(SockWait&)const=0;
  virtual bool Run(bool)=0;
  virtual int GetSock()const{return Con;}

  typedef sock::Input Inp_C;
  class Outp_C;
 protected:
  /*connection stuff*/
  sock::Socket_basic Con;
  VTQL::UserMode umLogin;  //mode of connection
  bool Poll(bool&,bool&)const;
};

//don't forget to do an explicit instantiation in showall.cc
template<typename T>
void operator <<(sock::Output&,const T&); 

class Connection_base::Outp_C:public sock::Output{
 public:
  Outp_C(const sock::Socket_basic&,size_t iS);
  virtual ~Outp_C(){delete[] cpTT;}
  void GetPage(const u_int8_t*,VTQL::ShowMode);
 private:
  char* cpTT;
};

#endif
