//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#include "db.h"

#include <libvtql/sock.h>
#include "station.h"
#include "error_class.h"

void Database::Insert(const vt_tv::PageTyp& vtp){
 vt_tv::PageTyp vtp_copy;
 vtp_copy << vtp;

 for(StationMap::iterator pms=smStations.begin();pms!=smStations.end();++pms)
  if(pms->second->Insert(vtp_copy))cb.Run(CallBType(vtp,pms->first));
}

void Database::GetPageL(size_t iRegID,SearchQueue::SmartRP rp){
 for(StationMap::iterator psi=smStations.begin();psi!=smStations.end();++psi)
  psi->second->FillResultL(iRegID,rp,sqSearch);
 sqSearch.Add2Queue(SearchQueue::SingleResult(iRegID,true),rp);
}

StationTyp& Database::operator[](size_t i){
 StationTyp* stp=smStations[i];
 if(!stp)throw Error::Exec(METH_NAME,"unknown station");
 return *stp;
}

void Database::AddStation(size_t i){
 StationTyp* stp=new StationTyp(i);
 if(smStations.AddIf(i,stp)!=stp)
  throw Error::Exec(METH_NAME,"station already exists");
}

void Database::DelStation(size_t i){
 if(!smStations.erase(i))throw Error::Exec(METH_NAME,"station not found");
}
