//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#include "station.h"

#include "db.h"

StationTyp::StationTyp(size_t i):iID(i),iTimeout(0),iCountPages(0){
 SetMatch(".none");
}

bool StationTyp::Insert(const vt_tv::PageTyp& pvtp){
 if(!regMatch->MatchPage(pvtp))return false;

 PageSet::iterator smi=psPages.find(pvtp); 
 if(smi!=psPages.end()){
  if(smi->tTime>pvtp.tTime)return false; //maybe your machine ist crazy :)
  tomPage.erase(smi);
  psPages.erase(smi);
 }
 smi=psPages.insert(StPageTyp(pvtp,++iCountPages)).first;
 tomPage.insert(smi);

 TO();
 return true;
}

void StationTyp::TO(){
 if(!iTimeout)return;
 TOMap::const_iterator i=tomPage.begin();
 std::list<PageSet::iterator> liBuf;
 for(;i!=tomPage.end() && ((*i)->tfakeT)+iTimeout <= iCountPages;++i)
  liBuf.push_back(*i);
 tomPage.erase(tomPage.begin(),i);
 while(!liBuf.empty()){
  psPages.erase(liBuf.front());
  liBuf.pop_front();
 }
}

void StationTyp::FillResultL(size_t iSID,SearchQueue::SmartRP rp,
 SearchQueue& sq){
 if(!rp->MatchStation(iID))return;
 const Region::SinglePageSet& ps=rp->GetSinglePages();
 if(ps.empty())
  for(PageSet::const_iterator psi=psPages.begin();psi!=psPages.end();++psi){
   SearchQueue::SqPageTyp sqpg(*psi,iID);
   SearchQueue::SingleResult sr(iSID,sqpg);
   sq.Add2Queue(sr,rp);
  }
 else
  for(Region::SinglePageSet::const_iterator spi=ps.begin();spi!=ps.end();++spi){
   PageSet::const_iterator i=psPages.find(
    vt_tv::PageTyp(vt_tv::VTPage_Info(spi->iPage,spi->iSPage))
   );
   if(i!=psPages.end()){
    SearchQueue::SqPageTyp sqpg(*i,iID);
    SearchQueue::SingleResult sr(iSID,sqpg);
    sq.Add2Queue(sr,rp);
   }
  }
}

void StationTyp::SetMatch(const std::string& s){
 SearchQueue::SmartRP p(new Region());
 p->NewString(s,"|\\");
 regMatch=p;
 sMatch=s;
}
