/* this a modified version of Edgar Toernig <froese@gmx.de> 's vbi.h, shipped
   with alevt 1.6.0
   2000-2002: changed by Matthias Kleinmann to fit VTQLserver
   Copyright (C) 1998-2000 Edgar Toernig <froese@gmx.de>
   All rights reserved.
*/
#ifndef VBI_H
#define VBI_H

#include <libvtql/extern/vt.h>
#include <libvtql/extern/lang.h>

#define PLL_ADJUST	4

struct raw_page
{
    struct vt_page page[1];
    struct enhance enh[1];
};

struct vbi_struct
{
    int fd;
    // raw buffer management
    int bufsize;		// nr of bytes sent by this device
    int bpl;			// bytes per line
    u32 seq;
    // page assembly
    struct raw_page rpage[8];	// one for each magazin
    struct raw_page *ppage;	// points to page of previous pkt0
    // phase correction
    int pll_fixed;		// 0 = auto, 1..2*PLL_ADJUST+1 = fixed
    int pll_adj;
    int pll_dir;
    int pll_cnt;
    int pll_err, pll_lerr;
    // v4l2 decoder data
    int bpb;			// bytes per bit * 2^16
    int bp8bl, bp8bh;		// bytes per 8-bit low/high
    int soc, eoc;		// start/end of clock run-in
};

struct vbi_struct *vbi_open(const char *vbi_dev_name, int fine_tune,
								int big_buf);
void vbi_close(struct vbi_struct *vbi);
void vbi_pll_reset(struct vbi_struct *vbi, int fine_tune);
void vbi_send(struct vt_page*);
void vbi_handler(struct vbi_struct *vbi, int fd);
#endif
