//content       "stand alone" c++ warper to alevt
//homepage      http://www.rzuser.uni-heidelberg.de/~mkleinma/VTQL/
//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#ifndef VT_VT_H
#define VT_VT_H

#include <string>
#include <libvtql/thread.h>

namespace vt_tv{ 
class PageTyp;

class VT_TV{ //use only one instance,it is thread save
 protected:
  mutable thread::Mutex mLock; 

  std::string sVideo,sVidChan,sVbi;  //name of devices
  int iVideodev;       //<0 if video not open
  void* vbip;          //==0 if vbi not open

  int iActF;           //freq in KHz, <0 on error/not opened device
  int iIgnorePage;     //#pages left to ignore
  PageTyp* vtDatap;     //alevt-callback writes to this pointer

  void Lock()  const{mLock.Lock();}
  void Unlock()const{mLock.UnLock();}
  
  //try to set freq (return success), not thread save, no exceptions
  bool SetFreq_U(int); 
 public:
  VT_TV();
  ~VT_TV();
  
  bool Video()const{Lock();bool b=(iVideodev>=0);Unlock();return b;}//open?
  bool Vbi()  const{Lock();bool b=(vbip!=NULL);     Unlock();return b;}//open?
  int GetFreq()const{Lock();int i=iActF;Unlock();return i;}//get freq
  
  
  bool OpenVideo();  //open video device 
  void CloseVideo(); //close device
  bool OpenVbi();    //open device and init alevt
  void CloseVbi();   //close device and stop alevt

  void SetVideo(const std::string&);
  void SetVideoChan(const std::string&);
   //set video device, must be closed
  void SetVbi  (const std::string&);//set vbi device, must be closed
  void SetFreq(int i); //set freq if device open
  bool GetVT(PageTyp&,int);  //try for int msec to get a page

  void vbi_send(void*);//alevt-callback
};

};

#endif

