//content       connects vt to database
//homepage      http://www.rzuser.uni-heidelberg.de/~mkleinma/VTQL/
//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#ifndef VTRUN_H
#define VTRUN_H

#include <map>
#include <string>
#include <libvtql/thread_util.h>
#include "vt_tv.h"
#include "vtpage.h"

namespace sock{class Output;}
class VT_Run://use only one instance
 public vt_tv::VT_TV { 
 public:
  struct PageThread:thread::Thread{
   typedef thread::CallBack<vt_tv::PageTyp> PageCallB;
   PageCallB cbPage;
   
   PageThread(VT_Run& vtr):Thread(),vt_run(vtr){};
   virtual void* Run(); 
   VT_Run& vt_run;
  } ptGetData;

  VT_Run();
  virtual ~VT_Run();
  
  //do autozapping if video device is open
  void Autozap();       
  void SetFreq(int);

  void OpenVideo();//same as VT_TV::, but keep track of autozapping
  void CloseVideo();
  void OpenVbi();
  void CloseVbi();

  //autozap stuff
  void ChangeZap(int,int);
  void ShowZap(int,sock::Output&);
 private:
  int iLastF;            //freq of last zap (like iActF, but keeps value on
			// closevideo)
  time_t tLastZap,tStop; //last zap, last time vbi and video were open on iLastF
  typedef std::map<int,int> AutozapMap;
  AutozapMap azmFreq;

  bool SetFreq_U(int);

  friend void operator <<(sock::Output&,const VT_Run&);
};

namespace FreqTab{
class GetList{
 public:
  GetList();
  GetList(const std::string&);
 private:
  int iE,iSt;

  friend void operator <<(sock::Output&,const GetList&);
};

};

#endif

