//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>
#include "smartptr.h"

template<class T,typename IDTypeT>
T* CachedExternIDMap<T,IDTypeT>::AddIf(IDTypeT ID,T* tp){
 if((*this)[ID])delete tp;
 else pC=mD.insert(std::make_pair(ID,tp)).first;
 return pC->second;
}

template<class T,typename IDTypeT>
T* CachedExternIDMap<T,IDTypeT>::operator [](IDTypeT ID)const{
 if(pC==end() || pC->first!=ID)pC=mD.find(ID);
 return ((pC!=end())?pC->second:NULL);
}

template<class T,typename IDTypeT>
bool CachedExternIDMap<T,IDTypeT>::erase(IDTypeT ID){ //dont use cache
 typename CachedExternIDMap<T,IDTypeT>::iterator i=mD.find(ID);
 if(i==end())return false;
 erase(i);
 return true;
}

template<class T,typename IDTypeT>
void CachedExternIDMap<T,IDTypeT>::erase
 (typename  CachedExternIDMap<T,IDTypeT>::iterator i){
 if(pC!=end() && i->first==pC->first)++pC;
 delete i->second;
 mD.erase(i);
}

template<class T,typename IDTypeT>
IDTypeT CachedInternIDMap<T,IDTypeT>::Add(T* tp){
 pC=mD.insert(end(),std::make_pair(++iID_C,tp));
 return iID_C;
}

template<class T,typename IDTypeT>
void CachedExternIDMap<T,IDTypeT>::clear(){
 for(typename CachedExternIDMap<T,IDTypeT>::iterator i=begin();i!=end();++i)
  delete i->second;
 mD.clear();
 pC=mD.end();
}

template <typename T,typename TAdd>
SmartPtr<T,TAdd>::SmartPtr(const SmartPtr<T,TAdd>& sp){
 ptr=sp.ptr;
 spRef=sp.spRef;
 ++(*spRef);
}

template <typename T,typename TAdd>
SmartPtr<T,TAdd>::~SmartPtr(){
 if(!--(*spRef)){delete ptr;delete spRef;}
}

template <typename T,typename TAdd>
SmartPtr<T,TAdd>& SmartPtr<T,TAdd>::operator =(
 const SmartPtr<T,TAdd>& sp) {
 if(!--(*spRef)){delete ptr;delete spRef;}
 ptr=sp.ptr;
 spRef=sp.spRef;
 ++(*spRef);
 return *this;
}

