//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>
#include "thread.h"

namespace thread{
template<class T>
static void* Th_Run(void *vp){
 return reinterpret_cast<T*>(vp)->Run();
}

template<class T>
bool Thread::Start(){
 semExit.ForceZero();
 return !pthread_create(&thrRun,NULL,Th_Run<T>,this);
}

inline std::pair<bool,void*> Thread::Stop(){
 std::pair<bool,void*> p;
 semExit.Post();
 p.first=!pthread_join(thrRun,&p.second);
 return p;
}

};
