//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>
#include "vtql_utils.h"
#include "error_base.h"

namespace VTQL{

const char* cppUserModes[]={"CONFIG","QUERY","EVENT","NOBODY",NULL};
const char* cppShowModes[]={"LIST","HEX","TEXT",NULL};

const unsigned VT_WIDTH=40;
const unsigned VT_HEIGHT=25;
#undef W
#undef H

#define SINGLE_COMMAND static const struct Command
#define NULL_COMMAND null_command
SINGLE_COMMAND  NULL_COMMAND[]={{"",-1}};

#define ALL_COMMANDS const struct Command* cmAllCmds[]

#include "vtql.syntax.inc"
#undef SINGLE_COMMAND
#undef NULL_COMMAND
#undef ALL_COMMANDS

std::string EscapeString(std::string s){
 for(size_t i=s.find('\'');i!=s.npos;i=s.find('\'',i+2))
  s.insert(i,"\'");

 s.insert(0,"\'"); 
 s+='\'';
 return s;
}

//oh yes, it _is_ slow!
const char* xstrcasestr(const char* cpS,const char* cpN){
 const char *cpNc=cpN;
 for(;*cpS;++cpS){
  if(*cpNc==xtoupper(*cpS)){
   if(!*++cpNc)return cpS-((cpNc-1)-cpN);
  }else cpNc=cpN;
 }
 return NULL;
}

}


